# 自定义Web API二次开发

## 业务场景

每个公司在用苍穹系统的同时，基本上都会存在在用的已有业务系统，不同的业务系统间会为了数据的互动互通，需要接口调用的需求。为了是苍穹平台能够整合与别整合的能力，苍穹在单据模型上封装了一套可以直接配置就可以提供外部调用的接口，同时在这套可伸缩可扩展框架的框架基础上，提供自定义的Web API 二次开发接口。

 

## 接口提供者-自定义Web API

插件接口基类 kd.bos.bill.IBillWebApiPlugin 实现其中的 doCustomService(Map<String, Object> params)方法

```java
import kd.bos.bill.IBillWebApiPlugin;
import kd.bos.entity.api.ApiResult;

import java.util.Map;

public class CustomWebAPI implements IBillWebApiPlugin {


    @Override
    public ApiResult doCustomService(Map<String, Object> params) {
        // params 自定义的传入参数
        //可以调用苍穹的业务逻辑

        //如对接到苍穹的工作流审批接口

        return ApiResult.success("压入需要返回给接口调用者的信息");
    }
}
```

示例：正常情况，我们是在苍穹里面处理工作流，有些业务场景需要把工作流的处理集成到客户的自己的手机端或者pc端处理界面，进行苍穹的工作流审核触发，

自定义Web API接口：

```
工作流自定义审批示例

```



## 接口使用者

调用时序图

 ![](image/clip_image001.png)

 

## getAppToken

请求参数：

```
POST：{苍穹url}/api/getAppToken.do
{
    "appId": "应用编码",
    "appSecuret": "应用密码",
    "tenantid": "租户Id",
    "accountId": "账套Id",
    "language": "zh_CN"
}
```

返回参数：

```
{
    "data": {
        "app_token": "获取的AppToken",
        "success": true,
        "error_desc": "",
        "expire_time": ,
        "error_code": "0"
    },
    "state": "success"
}
```



## 登录

请求参数：

```
POST:{苍穹url}/api/login.do
{
    "user": "用户身份",
    "apptoken": "取得的apptoken",
    "tenantid": "租户Id",
    "accountId": "账套Id",
    "usertype": "用户类型"
}
```

返回参数：

```
{
    "data": {
        "access_token": "获取的access_token",
        "success": true,
        "error_desc": "",
        "expire_time": ,
        "error_code": "0"
    },
    "state": "success"
}
```



## 调用接口

请求参数：

```

POST:{苍穹url}/kapi/app/{appId}/{servicename}/?access_token={access_token} 
HTTP请求头:Content-Type:application/json 

BODY:{自定义json串}

```

返回参数：

```
{自定义接口返回的json数据结构}
```





