
## 适用范围

 

第三方系统登录苍穹集成。

 

## 功能简介

第三方系统在调用苍穹云下一代平台API接口时首先第一步需要获得应用Token，第二步根据应用token和人员获得正式访问AccessToken，然后就可以根据正式token访问第三方系统有权限访问的所有API。应用token和正式访问AccessToken失效时间**默认2小时**。



## 主要调用过程



  ![1584671652793](images/1584671652793.png)



## 调用接口描述

### 获取应用token

 

[api访问地址前缀] /api/getAppToken.do          [**POST**]


-  接口描述：允许第三方系统通过API得到应用Token。

-  功能说明：根据第三方appid和appSecuret返回后续API访问所需要的app_token字串。。

-  HTTP请求方式：POST

-  请求参数格式：JSON

-  返回格式：JSON

-  调用限制：无

-  请求示例：

```java
http://localhost:8080/ierp/api/getAppToken.do
请求参数：
{
	"appId": "EAS",
	"appSecuret": "123456",
	 "accountId": "13525468784441"，
"language": "zh_CN"
}
返回结果：
{
	"data": {
		"app_token": "12324eroeutrekdfgfkdkkk",
		"success": true,
		"error_desc": "",
		"expire_time": 1535675659434,
		"error_code": "0"
	},
	"state": "success"
} 


```

- 参数说明

传入参数：

| **传入参数** | **字段类型** | **是否必输** | **字段说明**                                           |
| --- | ---| ------------ | ------------------------------------------------------ |
| appId        | string       | 是           | 第三方appId                                            |
| appSecuret   | string       | 是           | 第三方app的密码                                        |
| accountId    | string       | 否           | 数据中心ID，如果不输入，默认会选取租户下的缺省数据中心 |
| language     | String       | 否           | 语言字串：zh_CN,zh_TW等。默认系统默认语言              |

 

返回参数：

| **返回参数** | **字段类型** | **字段说明** |                        |
| ------------ | ------------ | ------------ | ---------------------- |
| data         | jason        |              |                        |
|              | app_token    | string       | 应用Token              |
|              | success      | string       | True或false            |
|              | error_desc   | string       | 错误消息               |
|              | expire_time  | long         | Token过期时间          |
|              | error_code   | string       | 0是成功，其他为错误    |
| state        |              | string       | 是否成功success或error |

 

 

### 登录API接口（一）

[api访问地址前缀] /api/login.do          [**POST**]



-  接口描述：允许第三方系统用户标识和标识类型登录到系统。适用于不需要知道用户密码的情况。

-  功能说明：根据用户标识和标识类登录到系统并返回后续API访问所需要的access_tokent字串。

-  HTTP请求方式：POST

-  请求参数格式：JSON

-  返回格式：JSON

-  调用限制：无

-  请求示例：

```java
http://localhost:8080/ierp/api/login.do请求参数：
{
	"user": "13825207590",
	"apptoken": "a3270799-b482-4697-931f-2fb68b56bdf2",
	 "accountId": "1235698752",
	"usertype": "Mobile"
}
返回结果：
{
	"data": {
		"access_token": "f035550a-f9e8-4cc6-a775-8a21462a9f8b",
		"success": true,
		"error_desc": "",
		"expire_time": 1535680289307,
		"error_code": "0"
	},
	"state": "success"
}


```

- 参数说明

传入参数：

| **传入参数** | **字段类型** | **是否必输** | **字段说明**                                                 |
| ------------ | ------------ | ------------ | ------------------------------------------------------------ |
| user         | string       | 是           | 用户标识                                                     |
| apptoken     | string       | 是           | AppToken                                                     |
|              |              |              |                                                              |
| accountId    | string       | 否           | 数据中心ID，如果不输入，默认会选取租户下的缺省数据中心       |
| usertype     | String       | 否           | Mobile： 标识为手机，默认为手机  Email：标识为email  UserName：标识为用户名 |
| language     | String       | 否           | 语言字串：zh_CN,zh_TW等。默认系统默认语言                    |

 

返回参数：

| **返回参数** | **字段类型** | **字段说明** |                                            |
| ------------ | ------------ | ------------ | ------------------------------------------ |
| data         | jason        |              |                                            |
|              | access_token | string       | API访问金蝶云标识，后续其他API访问需要使用 |
|              | success      | string       | True或false                                |
|              | error_desc   | string       | 错误消息                                   |
|              | expire_time  | long         | Token过期时间                              |
|              | error_code   | string       | 0是成功，其他为错误                        |
| state        |              | string       | 是否成功success或error                     |

特别说明，在用access_token访问的过程中，如果response error code的值为1，表示该access_token已经超时。

 

 

 

### 登录API接口（二）

[api访问地址前缀] /api/login.do          [**POST**]



-  接口描述：允许第三方系统通过API使用云之家和金蝶云的用户登录到系统。适用于需要知道用户名密码的情况。

-  功能说明：根据云之家或金蝶云的用户名密码登录到系统并返回后续API访问所需要的access_tokent字串。。

-  HTTP请求方式：POST

-  请求参数格式：JSON

-  返回格式：JSON

-  调用限制：无

-  请求示例：

```java
http://localhost:8080/ierp/api/login.do请求参数：
{
	"user": "13825207590",
	"password": "12345678",
    "apptoken": "a3270799-b482-4697-931f-2fb68b56bdf2",
	"logintype": "2"
}
请求结果：
{
	"data": {
		"access_token": "c4f0e545-ee4f-4cd5-9442-03bedbd982e2",
		"KERPSESSIONID": "c4f0e545-ee4f-4cd5-9442-03bedbd982e2",
		"success": true,
		"error_desc": "",
		"error_code": "0"
	},
	"state": "success"
}


```


- 参数说明

传入参数：

| **传入参数**  | **字段类型**  | **是否必输**  | **字段说明**                                           |
| ------------ | ------------ | ------------ | ------------------------------------------------------ |
| user         | string       | 是           | 金蝶云或云之家的用户名                                 |
| password     | string       | 是           | 金蝶云或云之家的密码                                   |
| apptoken     | string       | 是           | AppToken                                               |
| accountId    | string       | 否           | 数据中心ID，如果不输入，默认会选取租户下的缺省数据中心 |
| logintype    | String       | 否           | 0：云之家 2 苍穹云 默认为云之家方式                    |

返回参数：

| **返回参数** | **字段类型** | **字段说明** |                                            |
| ------------ | ------------ | ------------ | ------------------------------------------ |
| data         | jason        |              |                                            |
|              | access_token | string       | API访问金蝶云标识，后续其他API访问需要使用 |
|              | success      | string       | True或false                                |
|              | error_desc   | string       | 错误消息                                   |
|              | expire_time  | long         | Token过期时间                              |
|              | error_code   | string       | 0是成功，其他为错误                        |
| state        |              | string       | 是否成功success或error                     |

特别说明，在用access_token访问的过程中，如果response error code的值为1，表示该access_token已经超时。

 

## 退出登录API接口

[api访问地址前缀] /api/logout.do          [**POST**]

- 接口描述：第三方个人用户退出系统。

- 功能说明：根据用户access_tokent字串退出。

- HTTP请求方式：POST

- 请求参数格式：JSON

- 返回格式：JSON

- 调用限制：无

- 请求示例：

```java
http://localhost:8080/ierp/api/logout.do请求参数：
{
	" access_token": " f035550a-f9e8-4cc6-a775-8a21462a9f8b "
}
返回结果：
{
	"data": {
		"success": true,
		"error_desc": "",
		"error_code": "0"
	},
	"state": "success"
}
```

- 参数说明

传入参数：

| **传入参数** | **字段类型** | **是否必输** | **字段说明**     |
| ------------ | ------------ | ------------ | ---------------- |
| access_token | string       | 是           | 用户access_token |

 

返回参数：

| **返回参数** | **字段类型** | **字段说明** |                                            |
| ------------ | ------------ | ------------ | ------------------------------------------ |
| data         | jason        |              |                                            |
|              | success      | string       | True或false                                |
|              | error_desc   | string       | 错误消息                                   |
|              | error_code   | string       | 0是成功，其他为错误                        |
| state        |              | string       | 是否成功success或error                     |

特别说明，在用access_token访问的过程中，如果response error code的值为1，表示该access_token已经超时

## 调用方式

 

在api调用的http header中增加参数accessToken（最新版本），access_token（老版本）。

在api调用的http header中增加参数api ,值为 true（老版本）。

 