# 实体操作服务帮助类

`kd.bos.servicehelper.operation.OperationServiceHelper`实体操作服务类为实体操作的上层封装，简化实体操作服务调用操作。

举例，调用提交操作：

```java
OperationResult result = OperationServiceHelper.executeOperate("submit", FormId_Bill2, new DynamicObject[] { billObj2 }, OperateOption.create());
```



## API 概览 

| 方法                                                         | 说明     |
| ------------------------------------------------------------ | -------- |
| static OperationResult executeOperate(String operationKey, String entityNumber, DynamicObject[] dataEntities, OperateOption option) | 执行操作 |
| static OperationResult executeOperate(String operationKey, String entityNumber, Object[] ids, OperateOption option) | 执行操作 |



## API 详情

### 1、执行操作

```java
static OperationResult executeOperate(String operationKey, String entityNumber, DynamicObject[] dataEntities, OperateOption option) 
```

传入参数：

| 参数名称 | 参数         | 参数类型        | 是否必传 |
| -------- | ------------ | --------------- | -------- |
| 操作key  | operationKey | String          | 是       |
| 实体编码 | entityNumber | String          | 是       |
| 操作数据 | dataEntities | DynamicObject[] | 是       |
| 操作选项 | option       | OperateOption   | 是       |

返回数据：

**操作结果**，OperationResult



### 2、执行操作

```java
static OperationResult executeOperate(String operationKey, String entityNumber, Object[] ids, OperateOption option)
```

传入参数：

| 参数名称 | 参数         | 参数类型      | 是否必传 |
| -------- | ------------ | ------------- | -------- |
| 操作key  | operationKey | String        | 是       |
| 实体编码 | entityNumber | String        | 是       |
| 操作数据 | dataEntities | Object[]      | 是       |
| 操作选项 | option       | OperateOption | 是       |

返回数据：

**操作结果**，OperationResult

