# BOS设计器规范

### 业务对象编码(对象标识)

长度不超过36位，整个系统中不允许重复，对象名为字符、\_、数字

命名：{isv标识}\_{模块}\_{业务对象名}\[\_后缀\]

!> 对非金蝶原厂开发商，平台会在创建业务对象的时候自动加isv标志前缀。

后缀：
- 单据、基础资料、表单不加后缀；
- 列表后缀为list；
- 移动表单后缀为_m；
- 移动列表后缀为list_m；

示例：
- 凭证单据：gl_voucher
- 凭证单据其他布局：gl_voucherxxx
- 凭证列表：gl_voucherlist
- 凭证移动列表：gl_voucherlist_m
- 凭证移动单据布局：gl_voucher_m
- 凭证移动单据其他布局：gl_voucherxxx_m

### 业务对象中控件的标识（Key）

在当前对象中不允许重复

命名： {isv标识}\_{控件前缀}\_{标识名称}

**重要：平台没有自动添加isv标识，需要在设计时手工修改添加上去，避免以后和平台的控件标识重复，如是金蝶原厂开发则不需要添加**

**注：** 此处标识包括对象唯一标识、单据体标识、字段标识、控件标识

- 业务对象表结构由数据库模型（PDM）设计定义；
- 设计器中字段的字段名必须以f打头并且必须与数据模型一致；
- 业务对象不允许使用视图；
- 设计器业务对象主键属性，必须和表定义主键一致；
- 字段标识（Key）由字符数字和下划线组成，长度4-24；
- ORM属性命名真实反映元素具体含义，对应源代码实体属性名；
- ORM实体命名为字符‘\_’数字，不允许有中文和特殊字符；
- 设计器中表、字段、键、约束、缺省值全部大写，名称长度不超过24位（参照表设计规范）；
