单据操作插件
============

创建并注册插件
--------------

已经开发好的单据操作插件，通过如下步骤，绑定到操作上：

-   修改单据操作列表

![](media/0cb3766ec6fe29667ab40b70d460dbe7.png)

-   修改操作的配置

![](media/57b6ba9908e979c9a1bab50160779d8c.png)

-   绑定自定义操作插件

![](media/d61893ce818168e23403765293848f36.png)

常用方法与样例
--------------

**案例1：onAddValidators**


> 案例说明

1. 单据体中有”最迟送货日期”字段，子单据体中有”预计送货日期”字段；
2. 预计送货日期，不能晚于最迟送货日期；
3. 如果不满足此条件，该单不允许继续操作
4. 批量操作单据时，把不满足条件的单据剔除出去；其他满足条件的单据，可以继续操作；

> 实现方案

1. 捕获 onPreparePropertys事件，要求加载预计送货日期、最迟送货日期字段
2. 捕获 onAddValidators事件，添加自定义校验器
3. 实现自定义校验器，对预计送货日期、最迟送货日期，进行比较


> KS实例代码

![](media/a7d7ebbac90aa93a99926012d11fb2dd.png)

场景案例详见“金蝶云苍穹KDE脚本插件开发指南-V2.0”

<https://club.kdcloud.com/school/6104>
