# 基础卡片开发基本介绍
> 本页主要介绍基础首页配置卡片的方法，以及卡片的开发使用，开发者可以按照下面的步骤进行卡片的配置以及首页的卡片配置。
如果您有什么建议，欢迎在[金蝶社区](https://club.kdcloud.com/)留言反馈，我们会根据您的需求进行优化。
## 关于用户组和首页方案
### 1.关于用户组

> 用户组是用于首页方案分配时，设定的用户分组，管理员选择 “系统管理”

![img](images/clip_image004.png)

> 选择“首页定制-首页方案用户组”

![img](images/clip_image072.png)



> 在用户组列表界面，先维护左树，左树即用户组m

![img](images/clip_image006.png)

> 点击左树节点，右表会显示该组下包含的用户

![img](images/clip_image008.png)

### 2.首页方案

> 首页方案分为系统默认方案，共享方案，个性方案三种类型。
关于首页方案显示的逻辑：
一个用户登录到首页界面时，如果存在他的个性方案，则显示之；
否则，判断当前用户属于什么用户组，相应用户组是否被分配到某些共享方案下，如果是，则显示之，如果存在多个共享方案，显示其中一个（一般来说是最新设定的那个）；
否则，显示当前首页的系统默认方案。

> 管理员可以在“系统管理-首页定制-首页方案列表”中维护方案，例如可以删除方案，或启用/禁用方案，给共享方案分配用户组等。

![img](images/clip_image010.png)
> 方案的新增只能在首页界面进行调整布局时完成，详情请看后文

## 首页功能的基本使用方法
> 首页使用了栅格容器，可以自由添加与删除卡片，改变卡片大小，拖拽卡片位置等。点击右侧的“调整布局”按钮，可使栅格容器进入编辑态；个别卡片（如快速发起卡片）也存在编辑态，和栅格容器的编辑态保持一致。另外，个别卡片也支持在非编辑态进行编辑，例如快速发起卡片有一个+号按钮，在非编辑态也可以点击并添加内容。

![img](images/clip_image012.png)

> 栅格容器进入编辑态后，假如当前用户是超级管理员或者具有特定权限时（如“系统管理-首页定制-修改”的权限），右侧浮动按钮会出现“另存为”按钮，可以让当前布局另存为“共享方案”，可以分配给多个用户组。（事后可以回到系统管理-首页定制下重新维护分配的用户组）另外，右下角会出现“设为默认”复选框，用于标记当前方案作为系统默认方案。

![img](images/clip_image014.png)

> 如果当前方案是个性方案，那么右侧浮动按钮会出现“重置”按钮，点击后，会删掉当前用户的个性方案，那么当前首页会显示会为共享方案或系统默认方案（具体显示逻辑参考前文）
点击右侧的“切换”按钮，可以切换当前用户可以使用的首页布局方案。

![img](images/clip_image016.png)
> 在编辑态时，
   点“新增卡片”，可以选择需要添加的卡片类型（包括预置类型和自定义类型）。
   点“取消”，可以回到进入编辑态之前的卡片布局和设置状态。
   点“确定”，可把进入编辑态后，所有卡片布局以及每张卡片中的配置信息记录到数据库中。
  如果勾选了“设为默认”复选框，当前方案将被保存为系统默认方案，否则为当前用户的个性方案。

![img](images/clip_image018.png)
> 门户首页和应用首页使用方法一致。


## 快速发起卡片
> 快速发起卡片用于收藏用户的常用功能，并通过快捷入口快速发起某项业务。用户可以在快速发起卡片添加应用首页、业务功能、工作台或外部应用图标，点击图标可以直接打开业务功能。

1.选择快速发起卡片
![img](images/clip_image020.png)

> 点“确定”

![img](images/clip_image022.png)

2.选择需要快速添加的业务
![img](images/clip_image024.png)

> 点“确定”

![img](images/clip_image026.png)

3.添加外部链接
![img](images/clip_image028.png)

> 点“确定”

![img](images/clip_image030.png)

## 单据统计卡片
> 单据统计卡片为用户提供一个关键业务数据，方便用户重点关注关键业务情况。用户可以定制单据统计卡片，配置业务单据、单据列表过滤方案和统计方式。点击卡片上的关键数字可以进入业务单据列表，并按过滤方案展示数据。

![img](images/clip_image032.png)

> 用户可以定制单据统计卡片，配置业务单据、单据列表过滤方案和统计方式。

![img](images/clip_image034.png)

> 点击卡片上的关键数字可以进入业务单据列表，并按过滤方案展示数据。

![img](images/clip_image036.png)

## 多项统计卡片
> 多项单据统计卡片为用户提供多项关键业务数据，方便用户在宏观上概览关键业务情况。

![img](images/clip_image038.png)

> 用户可以在多项单据统计卡片中添加多个单据，配置单据列表过滤方案。点击卡片上的每个关键数字都可以进入业务单据列表。

![img](images/clip_image040.png)

> 并按过滤方案展示数据

![img](images/clip_image042.png)

## 云之家订阅卡片
> 云之家订阅号卡片，帮助用户随时了解公司动态。用户可以选择本人订阅的公众号来定制卡片，这样在首页就可以看到订阅号的内容摘要。点击云之家订阅号卡片可以进入该订阅号的首页。

![img](images/clip_image044.png)

> 必须在系统参数中启用了云之家，才能获取到云之家的订阅信息。
卡片使用了轮播容器，最多显示最近5条消息。
全员订阅的公共号，或者当前用户自主订阅的公共号才能被展示。

![img](images/clip_image046.png)

## 工作流卡片
> 工作流卡片统计工作流信息，帮助用户及时处理工作任务。用户可以选择待办任务、已办任务、在办申请、已办申请中的任何一个来定制工作流卡片，点击工作流卡片可以进入流程中心。

![img](images/clip_image048.png)

![img](images/clip_image050.png)

## 轻分析卡片

> 轻分析卡片为用户提供一个业务分析图表，方便用户实时掌握业务动态。

![img](images/clip_image052.png)

> 用户可以选择轻分析应用中的各种视图来定制轻分析卡片

![img](images/clip_image054.png)

> 点击轻分析卡片可以打开轻分析图表，编辑

![img](images/clip_image056.png)

## 自定义卡片
> 创建卡片：在首页中点击“添加卡片”，选择自定义卡片类型

![img](images/clip_image058.png)

> 新添加的卡片表单和动态表单无异，可开发插件形式比较自由，建议继承卡片模板插件：GridCardPlugin，它可获取当前卡片的配置，首页的全部卡片配置，是否编辑态等信息

> 进入应用

![img](images/clip_image060.png)

> 创建向导

![img](images/clip_image074.png)

> 选择卡片

![img](images/clip_image076.png)

> 点击下一步

![img](images/clip_image066.png)

> 选择所需要创建的卡片

![img](images/clip_image068.png)
