# 文档编写说明

> 该章节在于介绍如何编写文档，帮助编写文档的人员快速入门，该部分不属于文档的正式部分，后期发布前会隐藏。  
文档和我们的代码都是我们产品的重要资源，请每位灵魂写手认真对待，力求做到语言简洁、通俗易懂、结构清晰。

## 获取文档工程
文档的管理和我们的代码工程一样，存储在SVN上，目前文档只存在基线分支上，从SVN检出文档工程到本地即可。 

?> `http://192.168.16.99/svn/bos-server/tags/kd_bos_server_baseline/kd_bos_server/bos-server/package-server//static-file-service/webapp/devdoc`


## 编写工具
文档的编写统一采用`Markdown`语法，我们可以使用相关的编写工具帮助我们更快速编写，推荐使用Typora、MarkdownPad、 VScode等，总有一款适合你。

## 编写方法

![mulu.png](../resources/_media/mulu.png ':size=500')

使用markdown语法编写好文档后，只需把md文件放在对应的模块目录下，然后修改`_sidebar.md`文件，使得左侧导航把该文档连接起来即可，待设计师审核文档后即可提交到SVN。

!> PS：如果文档有带图片，可以在对应的模块目录下建`images`目录，统一管理

## 文档查看
该文档使用了运行时动态编译md为html的方法，所以需要把工程放到web容器下方可访问，目前已默认在我们的苍穹的webapp下，在基线环境下可直接使用`http://ip:port/baseline/devdoc/#`地址访问，后续文档也会作为我们产品的一部分跟随补丁一起发布出去。

## Markdown语法
支持常用Markdown的语法编写，如你还不够熟练该语法，详情可[查看](https://www.runoob.com/markdown)

**一些常用语法举例**

```md
 !> 一段重要的内容，可以和其他Markdown语法混用。
```
效果如下：

!> 一段重要的内容，可以和其他 **Markdown** 语法混用。

-----

```md
?> 这是普通的提示信息，可以和其他Markdown语法混用。
```
效果如下：

?> 普通的提示信息，可以和其他Markdown语法混用。

------

```md
> 这是一个区块，这是最外层
> > 第一层嵌套
> > > 第二层嵌套  
```
效果如下：

> 这是一个区块，这是最外层
> > 第一层嵌套
> > > 第二层嵌套  

--------
```md
![logo](../resources/_media/icon.svg ':size=50x100')   

![logo](../resources/_media/icon.svg ':size=100')

```
指定图片大小，效果如下：

![logo](../resources/_media/icon.svg ':size=50x100')
![logo](../resources/_media/icon.svg ':size=100')

ps：文档编写有任何疑问可以联系杨俊邦






