A公司流程场景
=============

需求分析
--------

### 流程分类

**出差申请（无借款）-\>差旅报销：**

处理员工差旅业务的流程，当员工出差之前，可根据公司的规定，提交出差申请单，作为预算事先管控的依据；

在完成出差后，由出差申请单生成差旅费报销单；

其他情况在此不做说明

### 审批过程 

1.  出差申请单（无借款），由直接领导审批，审批通过后下推生成差旅报销单

2.  差旅报销单，根据金额大小进行审批，如下图

>   项目出差时，则需要项目经理审批

![](media/e31e53d828c454801d94306ee74adf19.png)

1.  预算相关

2.  提交差旅报销单时就扣预算，流程被打回到提交之前的状态时返还预算

3.  共享节点核减金额时需返还预算

![](media/6691136785fe2e1364b3b4e1fb15d90f.png)

### 组织架构

![](media/3cab2a95aa6d443eec51cf63fc51fd4f.png)

各机构提单人都需要走审批流程，在审批时，流程的审批节点和金额有所不同

分析设置项
----------

### 流程分析

各个机构流程走向大致相同，只是审批节点和金额有所不同，可以用一个流程包含所有涉及到的审批节点，然后在节点上设置跳过条件（当满足跳过条件时，直接跳过当前审批节点），再使用动态配置方案，增加多个子方案的方式来实现，维护起来比较方便

### 审批人分析

1.  直接上级、间接上级、费用承担部门一级部门经理，可以通过人员、组织关系，使用关系类型的参与人实现

![](media/1ba11314ec32debbfcdc745fd796b632.png)

![](media/5caf95816d1fe22c516e942c80b41e8b.png)

1.  项目经理通过插件实现，通过项目号找项目经理

2.  其他审批节点用工作流角色实现，方便维护

配置流程 
---------

下面介绍差旅报销单的工作流配置

### 工作流角色

![](media/a60672197161f2de48dee0a737e361e9.png)

新增工作流角色

![](media/cb51931a307bff45cf9b0cc8cd15c866.png)

在设计器设置参与人时使用，如下图：

![](media/7071caa0ce58dcc69ba3d0c09dbec873.png)

### 单据摘要

新建移动单据摘要

![](media/eca032f6d6ca7d8c702a037c0a512b51.png)

在设计器中各节点配置所设置的移动单据摘要

![](media/13336b4e4ddf20c1b8b6880f397bfb63.png)

### 画流程图

按照向导建流程，最终流程图如下图所示：

![](media/31aeb77bbbd6fb7e3920b4682c6e5bcf.png)

### 节点属性配置

各个节点的配置项如下表所示：

| **序号** | **节点**                      | **设置项**                 | **设置详情**                                                                                                                                                                                                                                                                                                                                                             | **说明**                                                                                                                                                  |
|----------|-------------------------------|----------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------|
| 1        | 流程属性-启动条件             | 编制内员工                 | 差旅报销单.部门\<\>编制外人员 或                                                                                                                                                                                                                                                                                                                                         | 满足启动条件的单据才能进入到流程中。相关文档：https://club.kdcloud.com/article/183104                                                                     |
|          |                               |                            | 差旅报销单.部门.上级组织 不包含 编制外人员                                                                                                                                                                                                                                                                                                                               |                                                                                                                                                           |
| 2        | 流程属性-流程终止插件         | 预算扣减返还/置为废弃      |                                                                                                                                                                                                                                                                                                                                                                          |                                                                                                                                                           |
| 3        | 流程属性-单据例外设置         | 废弃/删除时终止流程        |                                                                                                                                                                                                                                                                                                                                                                          | 用户在单据列表删除或废弃时确保流程终止掉。相关文档：https://club.kdcloud.com/questions/151787/answers/181473                                              |
| 4        | 流程属性-流程变量             | 业务发起人                 | 业务发起人=差旅报销单.报销人                                                                                                                                                                                                                                                                                                                                             | 领导会委托助理报销，那么用委托报销时需要添加此变量。相关文档：https://club.kdcloud.com/article/183098                                                     |
| 5        | 单据提交节点插件              | 进入节点/离开节点          | 跳转进入时-设置审核不通过                                                                                                                                                                                                                                                                                                                                                | 1.确保跳转到人工节点时单据状态为“审核不通过”；2，3都是预算相关。相关文档：https://club.kdcloud.com/questions/14496/answers/19852                          |
|          |                               |                            | 驳回进入时-预算扣减返还                                                                                                                                                                                                                                                                                                                                                  |                                                                                                                                                           |
|          |                               |                            | 离开节点时-扣减预算                                                                                                                                                                                                                                                                                                                                                      |                                                                                                                                                           |
| 6        | 项目经理审批                  | 参与人插件                 | 寻找对应的项目经理                                                                                                                                                                                                                                                                                                                                                       | 根据项目号找项目经理。相关文档：https://club.kdcloud.com/article/146459                                                                                   |
| 7        |                               | 审批跳过条件               | 项目数据为空                                                                                                                                                                                                                                                                                                                                                             | 没有项目号则跳过此节点。相关文档：https://club.kdcloud.com/article/183104                                                                                 |
| 8        |                               | 自动审批条件               | 当前参与人=报销人                                                                                                                                                                                                                                                                                                                                                        | 当前参与人与报销人相同时自动跳过此节点。相关文档：https://club.kdcloud.com/article/183104                                                                 |
| 9        |                               | 审批页面增加“影像查看”按钮 | PC/移动                                                                                                                                                                                                                                                                                                                                                                  | PC/移动端菜单上显示出来“影像查看”按钮。相关文档：https://club.kdcloud.com/article/183131                                                                  |
| 10       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要。相关文档：https://club.kdcloud.com/article/183113                                                                                   |
| 11       |                               | 进入审批节点插件           | 设置“审核中”                                                                                                                                                                                                                                                                                                                                                             | 进入“项目经理审批”节点时单据变成“审核中”。相关文档：https://club.kdcloud.com/questions/14496/answers/19852                                                |
| 12       | 直接上级审批                  | 参与人                     | 单据.报销人的直接上级                                                                                                                                                                                                                                                                                                                                                    | 关系类型参与人，找报销人的直接上级。相关文档：https://club.kdcloud.com/questions/14767/answers/20075                                                      |
|          |                               |                            |                                                                                                                                                                                                                                                                                                                                                                          | https://club.kdcloud.com/article/183102                                                                                                                   |
| 13       |                               | 跳过条件                   | 当前参与人=报销人                                                                                                                                                                                                                                                                                                                                                        | 当前参与人与报销人相同时自动跳过此节点                                                                                                                    |
| 14       |                               | 重复审批人控制             | 自动审批                                                                                                                                                                                                                                                                                                                                                                 | 当前节点审批人与之前的审批人相同时自动审批。https://club.kdcloud.com/article/184369                                                                       |
| 15       |                               | 任务执行插件               | 驳回时设置“审核不通过”                                                                                                                                                                                                                                                                                                                                                   | 驳回到人工节点时，单据状态变成“审核不通过”                                                                                                                |
| 16       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 17       |                               | 可编辑内容                 | 可修改字段-附件；调用操作-保存                                                                                                                                                                                                                                                                                                                                           | 审批时可以修改附件，为了在提交时保存上修改后的结果，在此调用了保存操作，确保后面看到的就是修改后的结果。相关文档：https://club.kdcloud.com/article/183610 |
| 18       | 分管领导                      | 跳过条件                   | 差旅报销单.核定金额 \<= 10000 或                                                                                                                                                                                                                                                                                                                                         | 满足条件跳过则跳过此节点                                                                                                                                  |
|          |                               |                            | 当前参与人 = 报销人                                                                                                                                                                                                                                                                                                                                                      |                                                                                                                                                           |
| 19       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 20       |                               | 参与人                     | 工作流角色-分管领导                                                                                                                                                                                                                                                                                                                                                      | 选择工作流角色中所设置的参与人                                                                                                                            |
| 21       | 子公司负责人                  | 参与人                     | 工作流角色-子公司负责人，参数为单据.部门                                                                                                                                                                                                                                                                                                                                 | 选择工作流角色中所设置的参与人                                                                                                                            |
| 22       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 23       |                               | 跳过条件                   | 差旅报销单.核定金额 \<= 100000 或                                                                                                                                                                                                                                                                                                                                        | 满足条件跳过则跳过此节点                                                                                                                                  |
|          |                               |                            | 当前参与人 = 报销人                                                                                                                                                                                                                                                                                                                                                      |                                                                                                                                                           |
| 24       | 费用承担组织一级部门经理审批  | 参与人                     | 如果找到老总则为空角色（挂起），否则为报销单.费用承担部门.一级部门.负责人                                                                                                                                                                                                                                                                                                | 设置参与人条件，确保流程不要走到总裁那里                                                                                                                  |
| 25       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 26       |                               | 跳过条件                   | 差旅报销单.部门 = 差旅报销单.费用承担部门 或 当前参与人 = 报销人                                                                                                                                                                                                                                                                                                         | 满足条件跳过则跳过此节点                                                                                                                                  |
| 27       | 费用承担组织财务经理审批      | 参与人                     | 工作流角色-财务经理，参数为单据.费用承担公司                                                                                                                                                                                                                                                                                                                             | 选择工作流角色中所设置的参与人                                                                                                                            |
| 28       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 29       |                               | 跳过条件                   | 单据.申请人公司 = 费应承担公司 或 当前参与人 = 财务部总经理 或                                                                                                                                                                                                                                                                                                           | 满足条件跳过则跳过此节点                                                                                                                                  |
|          |                               |                            | 费用承担公司 = 集团总部                                                                                                                                                                                                                                                                                                                                                  |                                                                                                                                                           |
| 30       | 提交发票消息通知              | 消息                       | 人员-单据创建人；渠道-移动端/短信/邮件；消息内容根据客户需求设置                                                                                                                                                                                                                                                                                                         | 给提单人发消息，按照要求提交发票。相关文档：<https://club.kdcloud.com/article/183306>；https://club.kdcloud.com/article/183307                            |
| 31       | 共享审批                      | 属性设置支持               | 无参与人不能挂起；没有待办任务或不能显示出来                                                                                                                                                                                                                                                                                                                             |                                                                                                                                                           |
| 32       |                               | 节点插件-同意时            | 校验操作-核定提交；修改核定金额；返还预算差值                                                                                                                                                                                                                                                                                                                            | 进入共享中心，共享中心审批后返回结果继续走流程                                                                                                            |
| 33       | 费用复核岗审批                | 参与人                     | 工作流角色-费用复核岗，参数为部门                                                                                                                                                                                                                                                                                                                                        | 选择工作流角色中所设置的参与人                                                                                                                            |
| 34       |                               | 决策项                     | 同意，驳回至共享，驳回至人工节点                                                                                                                                                                                                                                                                                                                                         | 设置不同的决策项，在驳回时作为线上条件使用。相关文档：https://club.kdcloud.com/article/183136                                                             |
| 35       |                               | 跳过条件                   | 核定金额 \< 10000                                                                                                                                                                                                                                                                                                                                                        | 满足条件跳过则跳过此节点                                                                                                                                  |
| 36       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 37       |                               | 扩展按钮                   | 打印设置，查看影像                                                                                                                                                                                                                                                                                                                                                       | 相关文档：https://club.kdcloud.com/article/183131                                                                                                         |
| 38       | 共享中心总监审批              | 参与人                     | 工作流角色-共享总监，参数为部门                                                                                                                                                                                                                                                                                                                                          | 选择工作流角色中所设置的参与人                                                                                                                            |
| 39       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 40       |                               | 跳过条件                   | 核定金额 \< 50000                                                                                                                                                                                                                                                                                                                                                        | 满足条件跳过则跳过此节点                                                                                                                                  |
| 41       | 财务部总经理审批              | 参与人                     | 工作流角色-财务经理，参数为部门                                                                                                                                                                                                                                                                                                                                          | 选择工作流角色中所设置的参与人                                                                                                                            |
| 42       |                               | 跳过条件                   | 核定金额 \< 100000                                                                                                                                                                                                                                                                                                                                                       | 满足条件跳过则跳过此节点                                                                                                                                  |
| 43       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 44       | 设置为审核通过                | 操作                       | 审核通过服务                                                                                                                                                                                                                                                                                                                                                             | 自动审批节点，确保单据变成审核通过状态                                                                                                                    |
| 45       | 资金支付决策                  | 参与人                     | 财务经理                                                                                                                                                                                                                                                                                                                                                                 | 选择工作流角色中所设置的参与人                                                                                                                            |
| 46       |                               | 校验-同意/驳回             | 调用操作                                                                                                                                                                                                                                                                                                                                                                 |                                                                                                                                                           |
| 47       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 48       |                               | 节点处理插件-驳回          | 调用操作-出纳打回、设置状态                                                                                                                                                                                                                                                                                                                                              |                                                                                                                                                           |
| 49       |                               | 节点处理插件-处理人改变    | 调用插件-更新其他系统数据                                                                                                                                                                                                                                                                                                                                                |                                                                                                                                                           |
| 50       | 出纳审批                      | 参与人                     | 工作流角色-财务出纳                                                                                                                                                                                                                                                                                                                                                      | 选择工作流角色中所设置的参与人                                                                                                                            |
| 51       |                               | 同意时离开节点发消息       | 人员-报销人，创建人；渠道-移动端；                                                                                                                                                                                                                                                                                                                                       | 出纳节点同意后流程结束，同时给报销人发送消息通知。相关文档：<https://club.kdcloud.com/article/183306>；https://club.kdcloud.com/article/183307            |
|          |                               |                            | 内容：{model.applier.name}： 您好！ 您的差旅报销申请（{model.company.name} {model.applier.name} 差旅报销金额：{model.approveamount}，（流程单据号：{model.billno}），{model.description}）已审批通过并正在提交银行付款，请在两个工作日内关注资金到账情况! 如有疑问请与财务共享服务中心联系，TEL：xxx。 谢谢您的支持！ 财务共享服务中心                                   |                                                                                                                                                           |
| 52       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 53       | 凭证处理                      | 参与人                     | 工作流角色-凭证稽查岗                                                                                                                                                                                                                                                                                                                                                    | 选择工作流角色中所设置的参与人                                                                                                                            |
| 54       |                               | 决策项                     | 只设置“同意”，确认删除凭证                                                                                                                                                                                                                                                                                                                                               | 凭证处理出口线是到人工节点或共享节点                                                                                                                      |
| 55       |                               | 移动端页面                 | 单据摘要                                                                                                                                                                                                                                                                                                                                                                 | 选择所设置的单据摘要                                                                                                                                      |
| 56       |                               | 跳过条件                   | 差旅报销单.是否生成凭证=false                                                                                                                                                                                                                                                                                                                                            | 没有生成凭证时跳过此节点                                                                                                                                  |
| 57       | 连接线：资金决策审批-凭证处理 | 流转条件                   | 资金决策审批.结果=驳回到人工节点或驳回到共享审批节点                                                                                                                                                                                                                                                                                                                     | 驳回的时候按照决策项驳回到人工节点或者共享节点                                                                                                            |
| 58       | 自动节点-设置审批不通过       | 操作                       | 设置单据状态；返还预算扣减                                                                                                                                                                                                                                                                                                                                               |                                                                                                                                                           |

说明：CFO、CEO、董事会主席节点设置方式类似

### 动态配置方案

默认方案：流程设计模型，无条件

子方案：子公司方案/A类机构方案/B类机构方案/集团总部方案；继承默认方案进行简单修改，设置不同启动条件，如下图：

![](media/9708129e04e42a196817e674a9ab71ce.png)

详细文档入口：

金蝶云•苍穹流程服务云总体介绍

https://club.kdcloud.com/article/183308
