出口拆分设置&入口汇聚设置
=========================

**汇聚特性：**

-   并行分支进入条件灵活：可根据条件计算并行分支条数并流转，当符合条件的所有分支审批完成后到达汇聚节点

-   并行分支驳回后执行策略灵活：任意并行分支内的审批节点驳回后，再次进入并行分支，可全部重走或只走驳回分支

-   并行分支内的流程设置灵活：既可再次嵌套并行分支，也可嵌套排它（互斥）分支

-   分支汇聚支持众多节点控制功能：比如，节点跳过、自动审批、重复审批人控制等

功能介绍
--------

出口拆分设置&入口汇聚设置用于并行分支审批的场景，审批节点、会审节点、人工节点、自动节点都有此属性

![](media/7be534ee4a1dbe938a7fc09e1597d6e4.png)

简单汇聚流程的设置：

![](media/8812e624a8cece1309fd46d32bee18be.png)

![](media/51e4c43304da88cca9ecef88f7e903c7.png)

**汇聚并行分支流转与其他流转的区别**

![](media/5e8c671496f910b9c4b6f38f044477df.png)

应用场景
--------

**1.简单场景**

直接上级审批后，进入并行的两条分支，分支间互不影响，当分支全部审批通过后，才能到达汇聚节点，由出纳人员审批

设置要点：如下图

a.在工作流设计器中，打开拆分节点的“出口拆分设置”，选中“流出时，从所有满足条件的线流出”，根据实际业务场景灵活选择“拆分节点驳回后执行策略”

b.打开汇聚节点的“入口汇聚设置”

c.保存发布

注意：流程中的拆分节点和汇聚节点必须一一对应，数目一致，流程校验中有相应的校验

![](media/8812e624a8cece1309fd46d32bee18be.png)

![](media/51e4c43304da88cca9ecef88f7e903c7.png)

**2.复杂场景**

特殊场景，客户期望并行分支的审批人如果审批决策是驳回时，不立即驳回，而是等待其他节点处理完成后，在汇聚节点根据并行分支的结果来判断是否驳回

设置要点：

a.出口拆分节点和入口汇聚节点的属性设置

b.并行分支节点至入口拆分节点的连线上设置“线上条件规则”，节点决策结果=同意或驳回时，都走此线，如图1，图2

c.入口汇聚节点设置“自动审批条件规则”，4条分支结果中的任意一个=驳回，则此节点自动驳回，如图1，图3

d.入口汇聚节点设置“任务处理时限控制”，如图1，等待11分钟后，自动同意

![](media/e9b6456c323b8f3967078ee5aa462a48.png)

图1

![](media/0d9d407c06718f9857144ae59e9664b7.png)

图2

![](media/6b413c485214fab70c6d64fcb3e36821.png)

图3

**3.汇聚常见流程图**

场景1：

![](media/2d33c3398c309016f513da2cb4055f5b.png)

场景2：

![](media/0aba6dadbc3c70a7b4104691b6e05273.png)

场景3：

![](media/1c1db49afd76ebb2cf58d609fb7e5609.png)

场景4：

![](media/fc88e38b68a182e41e94d3949f7819da.png)
