条件规则
========

条件规则是一个独立的组件，用于设置工作流中各种条件规则，包括流程启动条件，跳过条件、参与人条件、自动审批条件、线上条件、动态配置方案子方案进入条件、消息通知发送条件、审批要点业务规则检查条件。条件规则可以在工作流设计器中被调用，也可以在流程管理中心的动态配置方案被调用。

条件规则设置说明
----------------

**1.参数说明**

条件规则较为灵活，支持多种参数的判断，可根据实际场景具体运用。参数分为2大类：单据相关字段和流程信息字段，如下图

![](media/f2a036b9ce2ad40e63fdcfbb6c85baed.png)

单据相关字段主要用于根据单据的字段、单据字段的扩展属性进行判断，详情如下：

![](media/43273581ebc3fddcb3d7fc010e444d2d.png)

![](media/f5ba777729e01fc4fcc16faee397358c.png)

图1

![](media/933857b17d96a25facdd5622012c9b0a.png)

图2

流程信息字段主要用于根据流程流转中的相关信息字段进行判断，详情如下：

![](media/7c642f1122f2994d13055ef83955cbe9.png)

**2.其他设置项**

![](media/addc28713398724b7890738969f005ef.png)

在此对包含、不包含、属于集合、不属于集合做如下解释：

![](media/5fae3ed78e21d9897ef3420464b69901.png)

流程启动条件
------------

-   有启动条件时，则会找符合启动条件的流程并进入，当同一个实体有多个流程都满足条件时，则进入最新的流程

-   没有启动条件时，则会找最新流程并进入

-   用户可以在工作流设计器中设置启动条件，也可以在管理中心设置启动条件

![](media/5e6c8340f61f70dc925c0d60e7ce7048.png)

![](media/aec4be1e20df21dc77b4fcedde707883.png)

**应用场景**

-   费用报销单建了多个流程，可通过设置不同的启动条件来确定进入哪个流程

节点跳过条件
------------

-   当流程走到某个节点时，会先判断是否满足跳过条件，当满足跳过条件时，则跳过，否则就进入此节点

![](media/66b623e759b1674bdbf72ad132304a7f.png)

![](media/b3df8be547750c1e040eedde97e71929.png)

**应用场景**

-   某集团审批不同金额的单据审批人不一样，金额足够大时才会有总经理或CEO审批，那么在设计流程时可以把需要审批的节点都放上去，通过跳过条件判断是否需要某领导审批

参与人条件
----------

-   当流程进入一个有参与人条件的节点后，会根据参与人条件找对应的参与人

![](media/c43a02cc86f071e57517bbfa38ac7474.png)

自动审批条件
------------

-   当流程进入一个有自动审批条件的节点后，会先判断是否满足自动审批条件，满足自动审批条件则自动审批，否则流程会找到当前节点的参与人进行人工审批

![](media/f71fbb5f7a8b0d3de5b77b19d91e8447.png)

线上条件
--------

-   流程运行时会判断线上条件，流程会自动流转到满足条件的分支线上

![](media/54aec19b75aac87aa2bef1de8b4e9c03.png)

动态配置方案中子方案进入条件
----------------------------

-   满足启动条件进入流程，当流程中有多个子方案时，则先找满足进入条件的子方案，找到满足条件的子方案则进入子方案，没有找到则进入默认方案

![](media/c2a3c3706091abc51ad73936ec152eb7.png)

消息通知发送条件
----------------

-   消息通知设置条件规则后，则符合条件规则才发送消息

-   消息通知条件为空时，则无条件发送消息

![](media/36dd2b4c6e184f24c9843311cc651621.png)

审批要点业务规则检查条件
------------------------

-   审批时，根据“规则”自动检查单据是否满足审批要点，详见“审批要点”

![](media/ce7de1b252f96a45533d97a8423e82e3.png)
